<?php
/**
 * Webkul Software.
 *
 * @category  Webkul
 * @package   Webkul_Eshopsync
 * @author    Webkul Software Private Limited
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */

namespace Webkul\SalesforceConnector\Controller\Adminhtml\Customers;

use Magento\Backend\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;

class ExportCustomers extends \Magento\Backend\App\Action
{
    /** @var \Magento\Framework\View\Result\PageFactory */
    protected $_resultPageFactory;

    /** @var \Webkul\Eshopsync\Helper\Connection */
    protected $_connection;

    /** @var \Magento\Framework\Json\Helper\Data */
    protected $_json;

    /** @var \Webkul\SalesforceConnector\Helper\Customer */
    protected $_customerHelper;

    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Webkul\SalesforceConnector\Helper\Connection $connection
     * @param \Magento\Framework\Json\Helper\Data $jsonHelper
     * @param \Webkul\SalesforceConnector\Helper\Customer $customerHelper
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        // \Webkul\SalesforceConnector\Helper\Connection $connection,
        \Magento\Framework\Json\Helper\Data $jsonHelper,
        \Webkul\SalesforceConnector\Helper\Customer $customerHelper,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory
    ) {
    
        parent::__construct($context);
        $this->_resultPageFactory = $resultPageFactory;
        // $this->_connection =$connection;
        $this->_json = $jsonHelper;
        $this->_customerHelper = $customerHelper;
    }

    public function execute()
    {
        $params = $this->getRequest()->getParams();
        $customerIds = $params['ids'];
        $result = ['skip' => 0 , 'err' => 0 ,'success' =>  0];
        if (\Webkul\SalesforceConnector\Helper\Connection::checkConnectionStatus()) {
            if (is_array($customerIds) && count($customerIds) > 0) {
                // if (count($customerIds) >= 200) {
                //     $this->messageManager->addError(__("Too Many selected. Use Export Instead"));
                // } else {
                    $result = $this->_customerHelper->exportCustomers($customerIds);
                // }
            }
        } else {
            $this->messageManager->addError(__("Check Connection"));
        }
        
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody($this->_json->jsonEncode($result));

        // $response = false;
        // $total = $params['total'];
        // $counter = $params['counter'];
        // $customerId = $params['id'];
        // $client = $this->_connection->getSforceConnection();
        // if ($customerId && $client['client']) {
        //     $response = $this->_customerHelper->syncSpecificCustomer($client['client'], $customerId);
        // }
        // if ($counter == $total) {
        //     $this->messageManager->addSuccess(
        //         __(
        //             "%1 Customer has been successfully synchronized."
        //         ),
        //         $total
        //     );
        // }
        // $this->getResponse()->setHeader('Content-type', 'application/json');
        // $this->getResponse()->setBody($this->_json->jsonEncode(['response'=>$params]));
    }

    /*
     * Check permission via ACL resource
     */
    // protected function _isAllowed()
    // {
    //     return $this->_authorization->isAllowed('Webkul_Eshopsync::customers_exportcustomer');
    // }
}
