<?php
/**
 * Webkul Software.
 *
 * @category  Webkul
 * @package   Webkul_Eshopsync
 * @author    Webkul
 * @copyright Copyright (c) 2010-2016 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */

namespace Webkul\SalesforceConnector\Ui\Component\Listing\Column;

use Magento\Framework\UrlInterface;
use Magento\Framework\View\Element\UiComponent\ContextInterface;
use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Ui\Component\Listing\Columns\Column;

/**
 * Class Productlink.
 */
class CatThumbnail extends Column
{
    /**
     * @var UrlInterface
     */
    protected $urlBuilder;
    protected $_catalogProduct;

    /**
     * Constructor.
     *
     * @param ContextInterface   $context
     * @param UiComponentFactory $uiComponentFactory
     * @param UrlInterface       $urlBuilder
     * @param array              $components
     * @param array              $data
     */
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        \Magento\Catalog\Helper\Image $imageHelper,
        \Magento\Catalog\Model\CategoryFactory $catalogCategory,
        \Magento\Framework\ObjectManagerInterface $objectManager,
        UrlInterface $urlBuilder,
        array $components = [],
        array $data = []
    ) {
        $this->urlBuilder = $urlBuilder;
        $this->_catalogCat = $catalogCategory;
                $this->imageHelper = $imageHelper;
                $this->_objectManager = $objectManager;
        parent::__construct($context, $uiComponentFactory, $components, $data);
    }

    /**
     * Prepare Data Source.
     *
     * @param array $dataSource
     *
     * @return array
     */
    public function prepareDataSource(array $dataSource)
    {
       
        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as &$item) {
                $category = $this->_catalogCat->create()->load($item['entity_id']);
                // $imageHelper = $this->imageHelper->init($product, 'product_listing_thumbnail');
                $imageUrl = $category->getImageUrl();
                if (!$imageUrl) {
                    $imageHelper = \Magento\Framework\App\ObjectManager::getInstance()->get(\Magento\Catalog\Helper\Image::class);
                    $placeholderImageUrl = $imageHelper->getDefaultPlaceholderUrl('image');
                    $item['preview'] = "<a href=".$this->urlBuilder->getUrl('catalog/category/edit', ['id' => $item['entity_id']])."target=blank title=".__('View Category')."><img src=".$placeholderImageUrl." width=50rem></img></a>";
                } else {
                    $item['preview'] = "<a href=".$this->urlBuilder->getUrl('catalog/category/edit', ['id' => $item['entity_id']])."target=blank title=".__('View Category')."><img src=".$imageUrl." width=100rem></img></a>";
                }
            }
        }

        return $dataSource;
    }
}
